module Minicontext
  class Environment
    attr_reader :request, :response, :memoized

    def initialize(request, response = nil)
      @request  = request
      @response = response
      @memoized = {}
    end

    def bind(val)
      dup.tap { |env| env.response = val }
    end

    def response=(val)
      raise AssignError, 'response' if response

      @response = val
    end

    def halt(*args)
      Halt.new(*args)
    end

    def fetch(name)
      (f = @context.lookup(name)) && f.(self).response
    end

    def action(&block)
      instance_eval(&block)
    end

    def short_circuit?
      Halt === @response
    end

    def call(context, &block)
      @context = context

      bind(short_circuit? ? @response : action(&block))
    end

    private

    def initialize_copy(obj)
      @context  = nil
      @response = nil
    end
  end
end
