module Minicontext
  class Router
    class Maybe
      def initialize(val)
        @val = val
      end

      def value
        @val
      end

      def [](name)
        klass = case val = @val.(name)
                when Context then Maybe
                when Proc    then Just
                else              Noting
                end

        klass.new(val)
      end
    end

    class Just < Maybe
      def [](name)
        Noting.new
      end
    end

    class Noting < Maybe
      def initialize(val = nil)
        @val = val
      end

      def [](name)
        self
      end

      def value
        nil
      end
    end
  end
end
